//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                            i-PSI@PolyMA_Trend.mq4 |
//|                                       Copyright  2013, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//|    21.04.2013     .                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-13, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color2 Blue    // UP
#property indicator_width2 2
#property indicator_color3 Red     // DW
#property indicator_width3 2
#property indicator_color4 Yellow  // FL
#property indicator_width4 2
#property indicator_minimum 0.0
#property indicator_maximum 1.0
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
#define BULL 0
#define BEAR 1
#define STOP -1
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                  *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
/*extern*/ bool      bb_VisualControl         = false;
#include         <bs-PSI@MAMs.mqh>                  //    MA
extern int       SignalOnBar              = 1;      //    ( )  
extern int       VerificationBars         = 2;      //      
extern int       Use_ATR.Filter           = 0;
/*extern*/ double    ATR_norm_factor          = 2.3;
extern int       ATR_Period               = 18;
//IIIIIIIIIIIIIIIIIII======  =====IIIIIIIIIIIIIIIIIIIIII+
double           Buf_DW[],                          // Down trend bars
                 Buf_UP[],                          // Up trend bars
                 Buf_FL[],                          // Fl trend bars 
                 Buf_Signal[],                      // Signal
                 Buf_Average[],                     //    
                 Buf_TMP[], Buf_Max[], Buf_Min[];
int              gi_Shift = 3, gi_PeriodIND, bi_Decimal;
//IIIIIIIIIIIIIIIIIII=========  =======IIIIIIIIIIIIIIIIIIIIII+
//#include         <b-PSI@Semaphore.mqh>              //     
#include         <bi-PSI@TMPL_IND.mqh>              //        .
#include         <b-PSI@BaseZF.mqh>                 //   
#include         <b-PSI@GrafOBJ.mqh>                //      
#include         <stdlib.mqh>                       //   
//|***********************************************************************************|
#import "b-PSI@Simple.ex4"
//|***********************************************************************************|
    double NDP (int v);              // ,  int  double  Point
    double NDD (double v);           //     Digits
    int fGet_SymbolInfo (string fs_Symbol);
                                     //     
//|***********************************************************************************|
#import
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom indicator initialization function                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int init()
{  
    //----     
    bia_PeriodMA[0] = MA_Period;
    bia_PeriodMA[1] = MA_Period * MA_K_Period;
//----
    string short_name,
           lsa_MethodName[] = {"SMA","EMA","Wilder","LWMA","SineWMA","TriMA","LSMA","SMMA","HMA",
                               "ZeroLagEMA","DEMA","T3","InstTrend","Median","GeometricMean","REMA",
                               "ILRS","IE/2","TriMA_gen","VWMA","JSmooth","T3M"},
           lsa_NamePrice[] = {"Close","Open","High","Low","Median","Typical","Weighted",
                               "HA Close","HA Open","HA High","HA Low"};
//----
	 //---- "  "  
	 //SemaphoreTake ("INIT");
    //----   
    bi_Decimal = fGet_SymbolInfo (Symbol());
    MA_Deviation *= bi_Decimal;
    bd_Deviation = NDP (MA_Deviation);
    gi_PeriodIND = MathMax (bia_PeriodMA[0], bia_PeriodMA[1]);
    //----      
    if (MA_Price > 10) MA_Price = 0;
    if (MA_Method > 21) MA_Method = 0;
    short_name = StringConcatenate ("PolyMA_Trend(", lsa_MethodName[MA_Method], "/", lsa_NamePrice[MA_Price], 
                                    "|", bia_PeriodMA[0], "/", bia_PeriodMA[1], ")");
    if (Use_ATR.Filter == 1) gi_PeriodIND = MathMax (gi_PeriodIND, ATR_Period);
    //----
    SetIndexStyle (0, DRAW_NONE);
    SetIndexBuffer (0, Buf_Signal);
    SetIndexLabel (0, "Signal");
    SetIndexDrawBegin (0, gi_PeriodIND);
    SetIndexEmptyValue (0, -1.);
    //----
    SetIndexStyle (1, DRAW_HISTOGRAM, 0, 2);
    SetIndexBuffer (1, Buf_UP);
    SetIndexLabel (1, "UP");
    SetIndexDrawBegin (1, gi_PeriodIND);
    SetIndexEmptyValue (1, 0.);
    //----
    SetIndexStyle (2, DRAW_HISTOGRAM, 0, 2);
    SetIndexBuffer (2, Buf_DW);
    SetIndexLabel (2, "DOWN");
    SetIndexDrawBegin (2, gi_PeriodIND);
    SetIndexEmptyValue (2, 0.);
    //----
    SetIndexStyle (3, DRAW_HISTOGRAM, 0, 2);
    SetIndexBuffer (3, Buf_FL);
    SetIndexLabel (3, "FLET");
    SetIndexDrawBegin (3, gi_PeriodIND);
    SetIndexEmptyValue (3, 0.);
    //----
    IndicatorDigits (0);
    IndicatorBuffers (4);
    IndicatorShortName (short_name);
	 //----    
	 //SemaphoreReturn ("INIT");
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custor indicator deinitialization function                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int deinit()
{
//----
    //if (Semaphore_ON) {SemaphoreClose();}
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom indicator iteration function                              |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{  
    int li_Limit = fGet_CalculateBars (gi_PeriodIND, Bars_Recalculate); 
//----
    if (li_Limit < 0) return (-1);
    if (li_Limit > Bars_Recalculate)
    {
        ArrayInitialize (Buf_Signal, STOP);
        ArrayInitialize (Buf_UP, 0.);
        ArrayInitialize (Buf_DW, 0.);
        ArrayInitialize (Buf_FL, 0.);
        //Print ("PolyMA_Trend: Limit - ", li_Limit);
    }
    double close_diff, ld_ATR, lda_Average[2], lda_Extrem[2], ld_MA, ld_Max, ld_Min, ld_curDeviation;
    int    li_Signal = STOP;
    bool   lb_ATR = true;
    static bool lb_first = true;
    while (li_Limit >= 0) 
    {
        li_Signal = fGet_SignalMA (Symbol(), Period(), ld_curDeviation, bd_Deviation, False, li_Limit + SignalOnBar, VerificationBars);
        //----    ATR-
        if (Use_ATR.Filter == 1)
        {
            ld_ATR = iATR (NULL, 0, ATR_Period, li_Limit) / ATR_norm_factor;
            close_diff = MathAbs (Close[li_Limit] - Close[li_Limit+gi_Shift]);
            lb_ATR = false;
            if (close_diff > ld_ATR) lb_ATR = true;
        }
        if (lb_ATR) 
        {
            if (li_Signal == BEAR)
            {
                Buf_DW[li_Limit] = 1.;
                Buf_Signal[li_Limit] = BEAR;
            }
            else if (li_Signal == BULL)
            {
                Buf_UP[li_Limit] = 1.;
                Buf_Signal[li_Limit] = BULL;
            }
        }
        if (Buf_DW[li_Limit] == 0.) if (Buf_UP[li_Limit] == 0.)
        {
            Buf_FL[li_Limit] = 1.;
            Buf_Signal[li_Limit] = STOP;
        }
        //----   
        li_Limit--;
    }
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

