//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                                 bi-PSI@MA_All.mqh |
//|                  Copyright  2007-13, Igor Stepovoi aka TarasBY & TrendLaboratory |
//|                                                                taras_bulba@tut.by |
//|   29.03.2013    MA ( )                       |
//|      
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-13, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
// List of MAs:
// MA_Method= 0: SMA        - Simple Moving Average
// MA_Method= 1: EMA        - Exponential Moving Average
// MA_Method= 2: Wilder     - Wilder Exponential Moving Average
// MA_Method= 3: LWMA       - Linear Weighted Moving Average 
// MA_Method= 4: SineWMA    - Sine Weighted Moving Average
// MA_Method= 5: TriMA      - Triangular Moving Average
// MA_Method= 6: LSMA       - Least Square Moving Average (or EPMA, Linear Regression Line)
// MA_Method= 7: SMMA       - Smoothed Moving Average
// MA_Method= 8: HMA        - Hull Moving Average by Alan Hull
// MA_Method= 9: ZeroLagEMA - Zero-Lag Exponential Moving Average
// MA_Method=10: DEMA       - Double Exponential Moving Average by Patrick Mulloy
// MA_Method=11: T3         - T3 by T.Tillson
// MA_Method=12: ITrend     - Instantaneous Trendline by J.Ehlers
// MA_Method=13: Median     - Moving Median
// MA_Method=14: GeoMean    - Geometric Mean
// MA_Method=15: REMA       - Regularized EMA by Chris Satchwell
// MA_Method=16: ILRS       - Integral of Linear Regression Slope 
// MA_Method=17: IE/2       - Combination of LSMA and ILRS 
// MA_Method=18: TriMAgen   - Triangular Moving Average generalized by J.Ehlers
// MA_Method=19: VWMA       - Volume Weighted Moving Average 
// MA_Method=20: JSmooth    - Smoothing by Mark Jurik
// MA_Method=21: T3M        - T3 modification
// List of Prices:
// Price    = 0 - Close  
// Price    = 1 - Open  
// Price    = 2 - High  
// Price    = 3 - Low  
// Price    = 4 - Median Price   = (High+Low)/2  
// Price    = 5 - Typical Price  = (High+Low+Close)/3  
// Price    = 6 - Weighted Close = (High+Low+Close*2)/4
// Price    = 7 - Heiken Ashi Close  
// Price    = 8 - Heiken Ashi Open
// Price    = 9 - Heiken Ashi High
// Price    =10 - Heiken Ashi Low
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                 *****                  *****                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIII=========  =======IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIII========  =======IIIIIIIIIIIIIIIIIIIIII+
double        bda_TMP[][6], bda_PriceHA[][4], bda_tmpTrend[][2], bda_tmpMA[],
              bda_C[4], bda_Koef[2], bd_T3_K = 0.7;
int           bi_preBars = 0, bi_LimitA, bi_flag = -1, bi_Bars,
              bi_Sound_Shift  =  0;    // 0-open bar (multiple), 1-closed bar (once)
bool          bb_Sound_Mode   =  FALSE; // True - works only with Color_Mode = true
string        bs_Buy_Sound    =  "alert.wav",
              bs_Sell_Sound   =  "alert2.wav";
//IIIIIIIIIIIIIIIIIII===========  =========IIIIIIIIIIIIIIIIIIIIII+
//|***********************************************************************************|
//| :                                                               |
//|***********************************************************************************|
/*int fInit_MA (int& fi_PriceMA,                  //      MA
                int& fi_MethodMA,                 //  
                int& fi_TF,                       // 
                int fi_PeriodMA)*/                //  
                                     //  
/*void fCalculate_MA (string fs_Symbol,           // 
                      int fi_TF,                  // 
                      int fi_PeriodMA,            //  
                      int fi_PriceMA,             //      MA
                      int fi_MethodMA,            //  
                      double ar_Price[],          //    
                      double& ar_BufMA[],         //    
                      double& ar_BufUP[],         //     MA
                      double& ar_BufDW[],         //     MA
                      double& ar_tmpMA[],         //   
                      double& ar_TMP[][],         //    
                      double& ar_PriceHA[][],     // ""   
                      double& ar_Trend[][],       //      MA
                      int fi_Total,               //  
                      int fi_Limit)*/             //   
                                     //     ar_Price[]
/*double fGet_MA (double ar_Price[],              //   
                  double ar_MA[],                 //   
                  double& ar_TMP[][],             //    
                  int fi_MethodMA,                //  
                  int fi_PeriodMA,                //  
                  int fi_Total,                   //  
                  int fi_Bar)*/                   // 
                                     //      
//|***********************************************************************************|
//| :   MA                                                         |
//|***********************************************************************************|
/*double SMA (double ar_Price[],                  //   
              int fi_Period,                      //  
              int fi_Bar)*/                       // 
                                     // MA_Method = 0: SMA - Simple Moving Average
/*double EMA (double fd_Price,                    //   
              double ar_MA[],                     //   
              int fi_Period,                      //  
              int fi_Bar)*/                       // 
                                     // MA_Method = 1: EMA - Exponential Moving Average
/*double Wilder (double ar_Price[],               //   
                 double ar_MA[],                  //   
                 int fi_Period,                   //  
                 int fi_Bar)*/                    // 
                                     // MA_Method = 2: Wilder - Wilder Exponential Moving Average
/*double LWMA (double ar_Price[],                 //   
               int fi_Period,                     //  
               int fi_Bar)*/                      // 
                                     // MA_Method = 3: LWMA - Linear Weighted Moving Average
/*double SineWMA (double ar_Price[],              //   
                  int fi_Period,                  //  
                  int fi_Bar)*/                   // 
                                     // MA_Method = 4: SineWMA - Sine Weighted Moving Average
/*double TriMA (double ar_Price[],                //   
                int fi_Period,                    //  
                int fi_Bar)*/                     // 
                                     // MA_Method = 5: TriMA - Triangular Moving Average
/*double LSMA (double ar_Price[],                 //   
               int fi_Period,                     //  
               int fi_Bar)*/                      // 
                                     // MA_Method = 6: LSMA - Least Square Moving Average (or EPMA, Linear Regression Line)
/*double SMMA (double ar_Price[],                 //   
               double ar_MA[],                    //   
               int fi_Period,                     //  
               int fi_Bar)*/                      // 
                                     // MA_Method = 7: SMMA - Smoothed Moving Average
/*double HMA (double ar_Price[],                  //   
              int fi_Period,                      //  
              int fi_Bar)*/                       // 
                                     // MA_Method = 8: HMA - Hull Moving Average by Alan Hull
/*double ZeroLagEMA (double ar_Price[],           //   
                     double ar_MA[],              //   
                     int fi_Period,               //  
                     int fi_Bar)*/                // 
                                     // MA_Method = 9: ZeroLagEMA - Zero-Lag Exponential Moving Average
/*double DEMA (int fi_IND,                        //  2-   ar_TMP
               double fd_Price,                   //   
               double& ar_TMP[][],                //  
               int fi_Period,                     //  
               double fd_K,                       //  
               int fi_Bar)*/                      // 
                                     // MA_Method = 10: DEMA - Double Exponential Moving Average by Patrick Mulloy
/*double T3 (double fd_Price,                     //   
             double& ar_TMP[][],                  //  
             int fi_Period,                       //  
             double fd_K,                         //  
             int fi_Bar)*/                        // 
                                     // MA_Method = 11: T3 by T.Tillson
/*double ITrend (double ar_Price[],               //   
                 double ar_MA[],                  //   
                 int fi_Period,                   //  
                 int fi_Bar)*/                    // 
                                     // MA_Method = 12: ITrend - Instantaneous Trendline by J.Ehlers
/*double Median (double ar_Price[],               //   
                 int fi_Period,                   //  
                 int fi_Bar)*/                    // 
                                     // MA_Method = 13: Median - Moving Median
/*double GeoMean (double ar_Price[],              //   
                  int fi_Period,                  //  
                  int fi_Bar)*/                   // 
                                     // MA_Method = 14: GeoMean - Geometric Mean
/*double REMA (double fd_Price,                   //   
               double ar_MA[],                    //   
               int fi_Period,                     //  
               double fd_Lambda,                  //  
               int fi_Bar)*/                      // 
                                     // MA_Method = 15: REMA - Regularized EMA by Chris Satchwell
/*double ILRS (double ar_Price[],                 //   
               int fi_Period,                     //  
               int fi_Bar)*/                      // 
                                     // MA_Method = 16: ILRS - Integral of Linear Regression Slope
/*double IE2 (double ar_Price[],                  //   
              int fi_Period,                      //  
              int fi_Bar)*/                       // 
                                     // MA_Method = 17: IE/2 - Combination of LSMA and ILRS
/*double TriMA_gen (double ar_Price[],            //   
                    int fi_Period,                //  
                    int fi_Bar)*/                 // 
                                     // MA_Method = 18: TriMAgen - Triangular Moving Average Generalized by J.Ehlers
/*double VWMA (double ar_Price[],                 //   
               int fi_Period,                     //  
               int fi_Total,                      //  
               int fi_Bar)*/                      // 
                                     // MA_Method = 19: VWMA - Volume Weighted Moving Average
/*double JSmooth (double fd_Price,                //   
                  double& ar_TMP[][],             //  
                  int fi_Period,                  //  
                  double fd_Pow,                  //  
                  int fi_Bar)*/                   // 
                                     // MA_Method = 20: JSmooth - Smoothing by Mark Jurik
/*double T3M (double fd_Price,                    //   
              double& ar_TMP[][],                 //  
              double ar_Koef[],                   //  
              int fi_Bar)*/                       // 
                                     // MA_Method = 21: T3 modification
//|***********************************************************************************|
//| :                                                           |
//|***********************************************************************************|
/*void fInit_T3M (int fi_Period,                  //  
                  double fd_K)*/                  //   c
                                     //     T3M
/*double HeikenAshi (int fi_VariantPrice,         //  
                     double& ar_PriceHA[][],      // ""    HeikenAshi
                     string fs_Symbol,            // Symbol
                     int fi_TF,                   // 
                     int fi_Bar = 1)*/            // 
                                     // HeikenAshi Price:  7 - Close, 8 - Open, 9 - High, 10 - Low
/*double fGet_Price (int fi_VariantPrice,         //  
                     double& ar_PriceHA[][],      // ""    HeikenAshi
                     string fs_Symbol,            // Symbol
                     int fi_TF,                   // 
                     int fi_Bar = 1)*/            // 
                                     //    fi_Bar 
/*void fPrepare_Arrays (int fi_Total,             //  
                        double& ar_tmpMA[],       //   
                        double& ar_TMP[][],       //    
                        double& ar_PriceHA[][],   // ""    HeikenAshi
                        double& ar_Trend[][],     //      MA
                        int fi_PriceMA,           //      MA
                        int fi_MethodMA)*/        //  
                                     //         
/*void fDraw_Buffers (double ar_tmpMA[],          //   
                      double& ar_Trend[][],       //      MA
                      int fi_Total,               //  
                      int fi_Bar)*/               // 
                                     //  MA   
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                     |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fInit_MA (int& fi_PriceMA,           //      MA
              int& fi_MethodMA,          //  
              int& fi_TF,                // 
              int fi_PeriodMA)           //  
{
//---- 
    if (fi_TF == 0 || fi_TF < Period()) fi_TF = Period();
    //----     
    if (fi_PriceMA > 10) fi_PriceMA = 0;
    if (fi_MethodMA > 21) fi_MethodMA = 0;
    if (fi_MethodMA == 21) fInit_T3M (fi_PeriodMA, bd_T3_K);
//----   
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|            ar_Price[]                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fCalculate_MA (string fs_Symbol,         // 
                    int fi_TF,                // 
                    int fi_PeriodMA,          //  
                    int fi_PriceMA,           //      MA
                    int fi_MethodMA,          //  
                    double ar_Price[],        //     ("" )
                    double& ar_BufMA[],       //    
                    double& ar_BufUP[],       //     MA
                    double& ar_BufDW[],       //     MA
                    double& ar_tmpMA[],       //   
                    double& ar_TMP[][],       //    
                    double& ar_PriceHA[][],   // ""   
                    double& ar_Trend[][],     //      MA
                    int fi_Total,             //  
                    int fi_Limit)             //   
{
//----
    //fCalculate_MA (Symbol(), TimeFrame, MA_Period, MA_Price, MA_Method, gda_Price, Buf_MA, Buf_UP, Buf_DW, bda_tmpMA, bda_TMP, bda_PriceHA, bda_tmpTrend, gi_Bars, li_Limit);
    if (fi_Total == fi_Limit) bi_LimitA = 0;
    //----        
    fPrepare_Arrays (fi_Total, ar_tmpMA, ar_TMP, ar_PriceHA, ar_Trend, fi_PriceMA, fi_MethodMA);
    int shift, li_Bars = fi_Total - 1; 
    if (bi_LimitA > 0) bi_LimitA--;
    for (int y = bi_LimitA; y < fi_Total; y++)
    {
        //----   MA
        ar_tmpMA[y] = fGet_MA (ar_Price, ar_tmpMA, ar_TMP, fi_MethodMA, fi_PeriodMA, fi_Total, y);
        if (y < fi_PeriodMA) continue;
        //----     
        fDraw_Buffers (ar_tmpMA, ar_Trend, fi_Total, y);
        if (fi_TF == Period())
        {
            ar_BufMA[li_Bars-y] = ar_tmpMA[y];
            if (Color_Mode)
            {
                ar_BufUP[li_Bars-y] = ar_Trend[y][0];
                ar_BufDW[li_Bars-y] = ar_Trend[y][1];
            }
        }
    }
    bi_LimitA = li_Bars;
    if (fi_TF > Period())
    { 
        fi_Limit = MathMax (fi_Limit, fi_TF / Period());
        for (shift = 0, y = 0; shift < fi_Limit; shift++)
        {
            if (shift < fi_PeriodMA) continue;
            if (Time[shift] < iTime (fs_Symbol, fi_TF, y)) y++;
            ar_BufMA[shift] = ar_tmpMA[li_Bars-y];
            if (Color_Mode)
            {
                ar_BufUP[shift] = ar_Trend[li_Bars-y][0];
                ar_BufDW[shift] = ar_Trend[li_Bars-y][1];
            }
        }
    }
//---- 
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_MA (double ar_Price[],         //   
                double ar_MA[],            //   
                double& ar_TMP[][],        //    
                int fi_MethodMA,           //  
                int fi_PeriodMA,           //  
                int fi_Total,              //  
                int fi_Bar)                // 
{
    double ld_MA = 0.;
//---- 
    switch (fi_MethodMA)
    {
        case 1 : ld_MA = EMA (ar_Price[fi_Bar], ar_MA, fi_PeriodMA, fi_Bar); break;
        case 2 : ld_MA = Wilder (ar_Price, ar_MA, fi_PeriodMA, fi_Bar); break;
        case 3 : ld_MA = LWMA (ar_Price, fi_PeriodMA, fi_Bar); break;
        case 4 : ld_MA = SineWMA (ar_Price, fi_PeriodMA, fi_Bar); break;
        case 5 : ld_MA = TriMA (ar_Price, fi_PeriodMA, fi_Bar); break;
        case 6 : ld_MA = LSMA (ar_Price, fi_PeriodMA, fi_Bar); break;
        case 7 : ld_MA = SMMA (ar_Price, ar_MA, fi_PeriodMA, fi_Bar); break;
        case 8 : ld_MA = HMA (ar_Price, fi_PeriodMA, fi_Bar); break;
        case 9 : ld_MA = ZeroLagEMA (ar_Price, ar_MA, fi_PeriodMA, fi_Bar); break;
        case 10: ld_MA = DEMA (0, ar_Price[fi_Bar], ar_TMP, fi_PeriodMA, 1, fi_Bar); break;
        case 11: ld_MA = T3 (ar_Price[fi_Bar], ar_TMP, fi_PeriodMA, bd_T3_K, fi_Bar); break;
        case 12: ld_MA = ITrend (ar_Price, ar_MA, fi_PeriodMA, fi_Bar); break;
        case 13: ld_MA = Median (ar_Price, fi_PeriodMA, fi_Bar); break;
        case 14: ld_MA = GeoMean (ar_Price, fi_PeriodMA, fi_Bar); break;
        case 15: ld_MA = REMA (ar_Price[fi_Bar], ar_MA, fi_PeriodMA, 0.5, fi_Bar); break;
        case 16: ld_MA = ILRS (ar_Price, fi_PeriodMA, fi_Bar); break;
        case 17: ld_MA = IE2 (ar_Price, fi_PeriodMA, fi_Bar); break;
        case 18: ld_MA = TriMA_gen (ar_Price, fi_PeriodMA, fi_Bar); break;
        case 19: ld_MA = VWMA (ar_Price, fi_PeriodMA, fi_Total, fi_Bar); break;
        case 20: ld_MA = JSmooth (ar_Price[fi_Bar], ar_TMP, fi_PeriodMA, 1, fi_Bar); break;
        case 21: ld_MA = T3M (ar_Price[fi_Bar], ar_TMP, bda_Koef, fi_Bar); break;
        default: ld_MA = SMA (ar_Price, fi_PeriodMA, fi_Bar); break;
    }
//---- 
    return (ld_MA);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|***********************************************************************************|
//| :   MA                                                         |
//|***********************************************************************************|
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=0: SMA - Simple Moving Average                                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double SMA (double ar_Price[],     //   
            int fi_Period,         //  
            int fi_Bar)            // 
{
    double Sum = 0.;
    int    li_cnt = 0;
//---- 
    for (int i = 0; i < fi_Period; i++)
    //{
        //if (ar_Price[fi_Bar-i] != EMPTY_VALUE) if (ar_Price[fi_Bar-i] > 0.)
        {Sum += ar_Price[fi_Bar-i]; li_cnt++;}
    //}
    //if (li_cnt == 0) li_cnt = 1;
//---- 
    return (Sum / fi_Period);
}                
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=1: EMA - Exponential Moving Average                                     |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double EMA (double fd_Price,        //   
            double ar_MA[],         //   
            int fi_Period,          //  
            int fi_Bar)             // 
{
    double ema = 0.;
//---- 
    if (fi_Bar <= 2) {ema = fd_Price;}
    else if (fi_Bar > 2) {ema = ar_MA[fi_Bar-1] + 2. / (1 + fi_Period) * (fd_Price - ar_MA[fi_Bar-1]);}
//---- 
    return (ema);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=2: Wilder - Wilder Exponential Moving Average                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double Wilder (double ar_Price[],     //   
               double ar_MA[],        //   
               int fi_Period,         //  
               int fi_Bar)            // 
{
    double wilder = 0.;
//---- 
    if (fi_Bar <= fi_Period) {wilder = SMA (ar_Price, fi_Period, fi_Bar);}
    else  if (fi_Bar > fi_Period) {wilder = ar_MA[fi_Bar-1] + (ar_Price[fi_Bar] - ar_MA[fi_Bar-1]) / fi_Period;}
//---- 
    return (wilder);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=3: LWMA - Linear Weighted Moving Average                                |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double LWMA (double ar_Price[],     //   
             int fi_Period,         //  
             int fi_Bar)            // 
{
    double lwma = 0., Sum = 0., Weight = 0.;
//---- 
    for (int i = 0; i < fi_Period; i++)
    { 
        //if (ar_Price[fi_Bar-i] != EMPTY_VALUE) if (ar_Price[fi_Bar-i] > 0.)
        //{
            Weight += (fi_Period - i);
            Sum += ar_Price[fi_Bar-i] * (fi_Period - i);
        //}
    }
    if (Weight > 0) {lwma = Sum / Weight;} else {lwma = 0.;}
//---- 
    return (lwma);
} 
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=4: SineWMA - Sine Weighted Moving Average                               |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double SineWMA (double ar_Price[],     //   
                int fi_Period,         //  
                int fi_Bar)            // 
{
    double swma = 0., pi = 3.1415926535, Sum = 0., Weight = 0.;
//---- 
    for (int i = 0; i < fi_Period - 1; i++)
    { 
        //if (ar_Price[fi_Bar-i] != EMPTY_VALUE) if (ar_Price[fi_Bar-i] > 0.)
        //{
            Weight += MathSin (pi * (i + 1) / (fi_Period + 1));
            Sum += ar_Price[fi_Bar-i] * MathSin (pi * (i + 1) / (fi_Period + 1));
        //}
    }
    if (Weight > 0) {swma = Sum / Weight;} else {swma = 0.;}
//---- 
    return (swma);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=5: TriMA - Triangular Moving Average                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double TriMA (double ar_Price[],     //   
              int fi_Period,         //  
              int fi_Bar)            // 
{
    double trima = 0., sma, sum = 0.;
    int len = MathCeil ((fi_Period + 1) * 0.5);
//---- 
    for (int i = 0; i < len; i++) 
    {
        sma = SMA (ar_Price, len, fi_Bar - i);
        if (sma > 0.) sum += sma;
    }
    trima = sum / len;
//---- 
    return (trima);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=6: LSMA - Least Square Moving Average (or EPMA, Linear Regression Line) |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double LSMA (double ar_Price[],     //   
             int fi_Period,         //  
             int fi_Bar)            // 
{   
    double lsma = 0., Sum = 0.;
//---- 
    for (int i = fi_Period; i >= 1; i--)
    {Sum += (i - (fi_Period + 1) / 3.) * ar_Price[fi_Bar-fi_Period+i];}
    lsma = Sum * 6. / (fi_Period * (fi_Period + 1));
//---- 
    return (lsma);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=7: SMMA - Smoothed Moving Average                                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double SMMA (double ar_Price[],     //   
             double ar_MA[],        //   
             int fi_Period,         //  
             int fi_Bar)            // 
{
    double smma = 0.;
//---- 
    if (fi_Bar <= fi_Period) {smma = SMA (ar_Price, fi_Period, fi_Bar);}
    else if (fi_Bar > fi_Period)
    {
        double Sum = 0.;
        for (int i = 0; i < fi_Period; i++) {Sum += ar_Price[fi_Bar-i-1];}
        smma = (Sum - ar_MA[fi_Bar-1] + ar_Price[fi_Bar]) / fi_Period;
    }
//---- 
    return (smma);
}                
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=8: HMA - Hull Moving Average by Alan Hull                               |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double HMA (double ar_Price[],     //   
            int fi_Period,         //  
            int fi_Bar)            // 
{
    double hma = 0., tmp[];
    int    len = MathSqrt(fi_Period);
//---- 
    ArrayResize (tmp, len);   
    if (fi_Bar <= fi_Period) {hma = ar_Price[fi_Bar];}
    else if (fi_Bar > fi_Period)
    {
       for (int i = 0; i < len; i++)
       {tmp[len-i-1] = 2. * LWMA (ar_Price, fi_Period / 2., fi_Bar - i) - LWMA (ar_Price, fi_Period, fi_Bar - i);}
       hma = LWMA (tmp, len, len - 1); 
    }  
//---- 
    return (hma);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=9: ZeroLagEMA - Zero-Lag Exponential Moving Average                     |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double ZeroLagEMA (double ar_Price[],     //   
                   double ar_MA[],        //   
                   int fi_Period,         //  
                   int fi_Bar)            // 
{
    double zema, alfa = 2. / (1. + fi_Period); 
    int lag = 0.5 * (fi_Period - 1); 
//---- 
    if (fi_Bar <= lag) {zema = ar_Price[fi_Bar];}
    else if (fi_Bar > lag)
    {zema = alfa * (2. * ar_Price[fi_Bar] - ar_Price[fi_Bar-lag]) + (1. - alfa) * ar_MA[fi_Bar-1];}
//---- 
    return (zema);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=10: DEMA - Double Exponential Moving Average by Patrick Mulloy          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double DEMA (int fi_IND,             //  2-   ar_TMP
             double fd_Price,        //   
             double& ar_TMP[][],     //  
             int fi_Period,          //  
             double fd_K,            //  
             int fi_Bar)             // 
{
    double ld_Dema = 0.;
//---- 
    if (fi_Bar <= 2)
    {
        ld_Dema = fd_Price;
        ar_TMP[fi_Bar][fi_IND] = ld_Dema;
        ar_TMP[fi_Bar][fi_IND+1] = ld_Dema;
    }
    else if (fi_Bar > 2) 
    {
        ar_TMP[fi_Bar][fi_IND] = ar_TMP[fi_Bar-1][fi_IND] + 2. / (1. + fi_Period) * (fd_Price - ar_TMP[fi_Bar-1][fi_IND]); 
        ar_TMP[fi_Bar][fi_IND+1] = ar_TMP[fi_Bar-1][fi_IND+1] + 2. / (1. + fi_Period) * (ar_TMP[fi_Bar][fi_IND] - ar_TMP[fi_Bar-1][fi_IND+1]); 
        ld_Dema = (1. + fd_K) * ar_TMP[fi_Bar][fi_IND] - fd_K * ar_TMP[fi_Bar][fi_IND+1];
    }
//---- 
    return (ld_Dema);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=11: T3 by T.Tillson                                                     |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double T3 (double fd_Price,        //   
           double& ar_TMP[][],     //  
           int fi_Period,          //  
           double fd_K,            //  
           int fi_Bar)             // 
{
    double T3 = 0.;
//---- 
    if (fi_Bar <= 2) 
    {
        T3 = fd_Price; 
        for (int k = 0; k <= 5; k++) {ar_TMP[fi_Bar][k] = T3;}
    }
    else if (fi_Bar > 2) 
    {
        double dema1 = DEMA (0, fd_Price, ar_TMP, fi_Period, fd_K, fi_Bar),
               dema2 = DEMA (2, dema1, ar_TMP, fi_Period, fd_K, fi_Bar); 
        T3 = DEMA (4, dema2, ar_TMP, fi_Period, fd_K, fi_Bar);
    }
    //if (T3 == 0.) {T3 = EMPTY_VALUE; Print ("Dema1[", fi_Bar, "] = ", dema1, " | Dema2[", fi_Bar, "] = ", dema2);}
//---- 
    return (T3);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=12: ITrend - Instantaneous Trendline by J.Ehlers                        |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double ITrend (double ar_Price[],     //   
               double ar_MA[],        //   
               int fi_Period,         //  
               int fi_Bar)            // 
{
    double it, alfa = 2. / (fi_Period + 1.);
//---- 
    if (fi_Bar > 7)
    {it = (alfa - 0.25 * alfa * alfa) * ar_Price[fi_Bar] + 0.5 * alfa * alfa * ar_Price[fi_Bar-1]
    - (alfa - 0.75 * alfa * alfa) * ar_Price[fi_Bar-2] + 2. * (1. - alfa) * ar_MA[fi_Bar-1]
    - (1 - alfa) * (1 - alfa) * ar_MA[fi_Bar-2];}
    else {it = (ar_Price[fi_Bar] + 2. * ar_Price[fi_Bar-1] + ar_Price[fi_Bar-2]) / 4.;}
//---- 
    return (it);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=13: Median - Moving Median                                              |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double Median (double ar_Price[],     //   
               int fi_Period,         //  
               int fi_Bar)            // 
{
    double array[], median;
//---- 
    ArrayResize (array, fi_Period);   
    for (int i = 0; i < fi_Period; i++) {array[i] = ar_Price[fi_Bar-i];}
    ArraySort (array);
    int num = MathRound ((fi_Period - 1.) / 2.); 
    if (MathMod (fi_Period, 2) > 0) {median = array[num];} else {median = 0.5 * (array[num] + array[num+1]);}
//---- 
    return (median); 
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=14: GeoMean - Geometric Mean                                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double GeoMean (double ar_Price[],     //   
                int fi_Period,         //  
                int fi_Bar)            // 
{
    double gmean = MathPow (ar_Price[fi_Bar], 1. / fi_Period); 
//---- 
    for (int i = 1; i < fi_Period; i++)
    {gmean *= MathPow (ar_Price[fi_Bar-i], 1. / fi_Period);}
//---- 
    return (gmean);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=15: REMA - Regularized EMA by Chris Satchwell                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double REMA (double fd_Price,       //   
             double ar_MA[],        //   
             int fi_Period,         //  
             double fd_Lambda,      //  
             int fi_Bar)            // 
{
    double alpha = 2. / (fi_Period + 1.), rema;
//---- 
    if (fi_Bar <= 3) rema = fd_Price;
    else if (fi_Bar > 3) 
    {rema = (ar_MA[fi_Bar-1] * (1. + 2. * fd_Lambda) + alpha * (fd_Price - ar_MA[fi_Bar-1]) - fd_Lambda * ar_MA[fi_Bar-2]) / (1. + fd_Lambda);}
//---- 
    return (rema);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=16: ILRS - Integral of Linear Regression Slope                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double ILRS (double ar_Price[],     //   
             int fi_Period,         //  
             int fi_Bar)            // 
{
    double sum = fi_Period * (fi_Period - 1) * 0.5,
           sum2 = (fi_Period - 1.) * fi_Period * (2. * fi_Period - 1.) / 6.,
           sum1 = 0., sumy = 0.;
//---- 
    for (int i = 0; i < fi_Period; i++)
    { 
        sum1 += (i * ar_Price[fi_Bar-i]);
        sumy += ar_Price[fi_Bar-i];
    }
    double num1 = fi_Period * sum1 - sum * sumy,
           num2 = sum * sum - fi_Period * sum2, slope;
    if (num2 != 0.) slope = num1 / num2; else slope = 0.; 
//---- 
    return (slope + SMA (ar_Price, fi_Period, fi_Bar));
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=17: IE/2 - Combination of LSMA and ILRS                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double IE2 (double ar_Price[],     //   
            int fi_Period,         //  
            int fi_Bar)            // 
{return (0.5 * (ILRS (ar_Price, fi_Period, fi_Bar) + LSMA (ar_Price, fi_Period, fi_Bar)));}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=18: TriMAgen - Triangular Moving Average Generalized by J.Ehlers        |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double TriMA_gen (double ar_Price[],     //   
                  int fi_Period,         //  
                  int fi_Bar)            // 
{
    int    len1 = MathFloor ((fi_Period + 1.) * 0.5),
           len2 = MathCeil ((fi_Period + 1.) * 0.5);
    double trimagen, sum = 0.;
//---- 
    for (int i = 0; i < len2; i++)
    {sum += SMA (ar_Price, len1, fi_Bar - i);}
//---- 
    return (sum / len2);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=19: VWMA - Volume Weighted Moving Average                               |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double VWMA (double ar_Price[],     //   
             int fi_Period,         //  
             int fi_Total,          //  
             int fi_Bar)            // 
{
    double vwma, Sum = 0., Weight = 0.;
//---- 
    for (int i = 0; i < fi_Period; i++)
    { 
        Weight+= Volume[fi_Total-fi_Bar-1+i];
        Sum += ar_Price[fi_Bar-i] * Volume[fi_Total-fi_Bar-1+i];
    }
    if (Weight > 0) {vwma = Sum / Weight;} else vwma = 0.; 
//---- 
    return (vwma);
} 
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| MA_Method=20: JSmooth - Smoothing by Mark Jurik                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double JSmooth (double fd_Price,        //   
                double& ar_TMP[][],     //  
                int fi_Period,          //  
                double fd_Pow,          //  
                int fi_Bar)             // 
{
    double beta = 0.45 * (fi_Period - 1) / (0.45 * (fi_Period - 1.) + 2.),
	        alpha = MathPow (beta, fd_Pow);
//---- 
	 if (fi_Bar <= 2)
	 {
	     ar_TMP[fi_Bar][4] = fd_Price;
	     ar_TMP[fi_Bar][0] = fd_Price;
	     ar_TMP[fi_Bar][2] = fd_Price;
	 }
	 else if (fi_Bar > 2) 
    {
	     ar_TMP[fi_Bar][0] = (1. - alpha) * fd_Price + alpha * ar_TMP[fi_Bar-1][0];
	     ar_TMP[fi_Bar][1] = (fd_Price - ar_TMP[fi_Bar][0]) * (1. - beta) + beta * ar_TMP[fi_Bar-1][1];
	     ar_TMP[fi_Bar][2] = ar_TMP[fi_Bar][0] + ar_TMP[fi_Bar][1];
	     ar_TMP[fi_Bar][3] = (ar_TMP[fi_Bar][2] - ar_TMP[fi_Bar-1][4]) * MathPow ((1. - alpha), 2) + MathPow (alpha, 2) * ar_TMP[fi_Bar-1][3];
	     ar_TMP[fi_Bar][4] = ar_TMP[fi_Bar-1][4] + ar_TMP[fi_Bar][3]; 
    }
//---- 
    return (ar_TMP[fi_Bar][4]);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|        MA_Method = 21: T3 modification                                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double T3M (double fd_Price,       //   
            double& ar_TMP[][],    //  
            double ar_Koef[],      //  
            int fi_Bar)            // 
{
    double T3 = 0.;
//---- 
    if (fi_Bar <= 2) 
    {
        T3 = fd_Price; 
        for (int li_pos = 0; li_pos < 6; li_pos++) {ar_TMP[fi_Bar][li_pos] = T3;}
    }
    else if (fi_Bar > 2) 
    {
        for (int li_IND = 0; li_IND < 6; li_IND++)
        {
            if (li_IND == 0) ar_TMP[fi_Bar][li_IND] = ar_Koef[0] * fd_Price + ar_Koef[1] * ar_TMP[fi_Bar-1][li_IND];
            else ar_TMP[fi_Bar][li_IND] = ar_Koef[0] * ar_TMP[fi_Bar][li_IND-1] + ar_Koef[1] * ar_TMP[fi_Bar-1][li_IND];
        }
        for (li_IND = 5; li_IND >= 2; li_IND--)
        {T3 += (bda_C[li_IND-2] * ar_TMP[fi_Bar][li_IND]);}
    }
//---- 
    return (T3);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|***********************************************************************************|
//| :                                                           |
//|***********************************************************************************|
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|            T3M                                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fInit_T3M (int fi_Period,     //  
                double fd_K)       //   c
{
    double lda_A[2], ld_N = fi_Period;
//---- 
    lda_A[0] = fd_K * fd_K;
    lda_A[1] = lda_A[0] * fd_K;
    bda_C[3] = -lda_A[1];
    bda_C[2] = (3. * (lda_A[0] + lda_A[1]));
    bda_C[1] = -3. * (2. * lda_A[0] + fd_K + lda_A[1]);
    bda_C[0] = (1. + 3. * fd_K + lda_A[1] + 3. * lda_A[0]);
    if (ld_N < 1) ld_N = 1;
    ld_N = 1. + 0.5 * (ld_N - 1.);
    bda_Koef[0] = 2. / (ld_N + 1.);
    bda_Koef[1] = 1. - bda_Koef[0];
//---- 
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//| HeikenAshi Price:  7 - Close, 8 - Open, 9 - High, 10 - Low                        |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double HeikenAshi (int fi_VariantPrice,     //  
                   double& ar_PriceHA[][],  // ""    HeikenAshi
                   string fs_Symbol,        // Symbol
                   int fi_TF,               // 
                   int fi_Bar = 1)          // 
{ 
//---- 
    if (fi_Bar == fGet_BarsOnSymbol (fs_Symbol, fi_TF) - 1) 
    {
        for (int li_IND = 0; li_IND < 3; li_IND++)
        {ar_PriceHA[fi_Bar][li_IND] =  fGet_PriceOnBar (li_IND, fs_Symbol, fi_TF, fi_Bar);}
    }
    else
    {
        ar_PriceHA[fi_Bar][0] = 0.;
        for (li_IND = 0; li_IND < 4; li_IND++)
        {ar_PriceHA[fi_Bar][0] += fGet_PriceOnBar (li_IND, fs_Symbol, fi_TF, fi_Bar);}
        ar_PriceHA[fi_Bar][0] /= 4.;
        ar_PriceHA[fi_Bar][1] = (ar_PriceHA[fi_Bar+1][1] + ar_PriceHA[fi_Bar+1][0]) / 2.;
        ar_PriceHA[fi_Bar][2] = MathMax (fGet_PriceOnBar (2, fs_Symbol, fi_TF, fi_Bar), MathMax (ar_PriceHA[fi_Bar][1], ar_PriceHA[fi_Bar][0]));
        ar_PriceHA[fi_Bar][3] = MathMin (fGet_PriceOnBar (3, fs_Symbol, fi_TF, fi_Bar), MathMin (ar_PriceHA[fi_Bar][1], ar_PriceHA[fi_Bar][0]));
    }
//---- 
    return (ar_PriceHA[fi_Bar][fi_VariantPrice]);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|           fi_Bar                                                |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_Price (int fi_VariantPrice,     //  
                   double& ar_PriceHA[][],  // ""    HeikenAshi
                   string fs_Symbol,        // Symbol
                   int fi_TF,               // 
                   int fi_Bar = 1)          // 
{
//----
    if (fi_VariantPrice <= 6) {return (iMA (fs_Symbol, fi_TF, 1, 0, 0, fi_VariantPrice, fi_Bar));}
    fi_VariantPrice = fi_VariantPrice - 7;
//---- 
    return (HeikenAshi (fi_VariantPrice, ar_PriceHA, fs_Symbol, fi_TF, fi_Bar));
}     
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fPrepare_Arrays (int fi_Total,               //  
                      double& ar_tmpMA[],         //   
                      double& ar_TMP[][],         //    
                      double& ar_PriceHA[][],     // ""    HeikenAshi
                      double& ar_Trend[][],       //      MA
                      int fi_PriceMA,             //      MA
                      int fi_MethodMA)            //  
{
//----
    //fPrepare_Arrays (gi_Bars, tmpMA, ar_TMP, ar_PriceHA, ar_Trend, fi_PriceMA, fi_MethodMA);
    if (bi_preBars == fi_Total) return;
    ArrayResize (ar_tmpMA, fi_Total);
    bool lba_CondON = true;
    if (fi_MethodMA != 10) if (fi_MethodMA != 11) if (fi_MethodMA != 20) if (fi_MethodMA != 21) lba_CondON = false;
    if (lba_CondON) {ArrayResize (ar_TMP, fi_Total);}
    if (Color_Mode) ArrayResize (ar_Trend, fi_Total);
    if (fi_PriceMA > 6) ArrayResize (ar_PriceHA, fi_Total);
    bi_preBars = fi_Total;
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|         MA                                               |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fDraw_Buffers (double ar_tmpMA[],       //   
                    double& ar_Trend[][],    //      MA
                    int fi_Total,            //  
                    int fi_Bar)              // 
{
//----
    if (!Color_Mode) return;
    if (ar_tmpMA[fi_Bar] > ar_tmpMA[fi_Bar-1]) {ar_Trend[fi_Bar][0] = ar_tmpMA[fi_Bar]; ar_Trend[fi_Bar][1] = EMPTY_VALUE;}
    else if (ar_tmpMA[fi_Bar] < ar_tmpMA[fi_Bar-1]) {ar_Trend[fi_Bar][0] = EMPTY_VALUE; ar_Trend[fi_Bar][1] = ar_tmpMA[fi_Bar];}
    else {ar_Trend[fi_Bar][0] = EMPTY_VALUE; ar_Trend[fi_Bar][1] = EMPTY_VALUE;}
    if (bb_Sound_Mode) if (fi_Bar == fi_Total - 1)
    {
        if (((bi_Sound_Shift > 0 && bi_flag != BULL) || bi_Sound_Shift == 0)
        && ar_tmpMA[fi_Bar-bi_Sound_Shift] > ar_tmpMA[fi_Bar-1-bi_Sound_Shift] && ar_tmpMA[fi_Bar-1-bi_Sound_Shift] <= ar_tmpMA[fi_Bar-2-bi_Sound_Shift])
        {
            if (bi_Sound_Shift > 0) {bi_flag = BULL;}
            PlaySound (bs_Buy_Sound);
        }
        else if ((bi_Sound_Shift > 0 && bi_flag != BEAR) || bi_Sound_Shift == 0)
        if (ar_tmpMA[fi_Bar-bi_Sound_Shift] < ar_tmpMA[fi_Bar-1-bi_Sound_Shift]) if (ar_tmpMA[fi_Bar-1-bi_Sound_Shift] >= ar_tmpMA[fi_Bar-2-bi_Sound_Shift])
        {
            if (bi_Sound_Shift > 0) {bi_flag = BEAR;}
            PlaySound (bs_Sell_Sound);
        }
    }
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

