//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                               i-PSI@MA Signal.mq4 |
//|                                       Copyright  2012, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//|    07.11.2012      bs-PSI@MAMs.mqh             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-13, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color2 LightSeaGreen // UP
#property indicator_width2 2
#property indicator_color3 Magenta       // DW
#property indicator_width3 2
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
#define       BULL          0
#define       BEAR          1
#define       STOP         -1
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                  *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool          bb_VisualControl;
/*extern*/ bool   IsVisualControl          = TRUE;     //    
#include      <bs-PSI@MAMs.mqh>                    //    MA
extern int    SignalOnBar              = 1;        //    ( )  
extern int    VerificationBars         = 2;        //      
//IIIIIIIIIIIIIIIIIII======  =====IIIIIIIIIIIIIIIIIIIIII+
double        Buf_DW[],                            // Down trend bars
              Buf_UP[],                            // Up trend bars
              Buf_Signal[],                        // Signal
              //bd_Deviation,
              UpperArrowDisplacement = 0.2,
              LowerArrowDisplacement = 0.2;
int           bi_Decimal;
string        bs_Error = "";
bool          bb_ControlBeginChangeTrend;
//IIIIIIIIIIIIIIIIIII=========  =======IIIIIIIIIIIIIIIIIIIIII+
//#include      <b-PSI@Semaphore.mqh>                //     
#include      <bi-PSI@TMPL_IND.mqh>                //        .
#include      <b-PSI@BaseZF.mqh>                   //   
#include      <b-PSI@GrafOBJ.mqh>                  //      
#include      <stdlib.mqh>                         //   
//|***********************************************************************************|
#import "b-PSI@Simple.ex4"
//|***********************************************************************************|
    double NDP (int v);              // ,  int  double  Point
    double NDD (double v);           //     Digits
    int fGet_SymbolInfo (string fs_Symbol);
                                     //     
//|***********************************************************************************|
#import
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom indicator initialization function                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int init()
{  
//----
	 //---- "  "  
	 //SemaphoreTake ("INIT");
    //----   
    bi_Decimal = fGet_SymbolInfo (Symbol());
    MA_Deviation *= bi_Decimal;
    bd_Deviation = NDP (MA_Deviation);
    //----
    SetIndexStyle (0, DRAW_NONE);
    SetIndexBuffer (0, Buf_Signal);
    SetIndexLabel (0, "Signal");
    SetIndexEmptyValue (0, STOP);
    //----
    SetIndexStyle (1, DRAW_ARROW);
    SetIndexBuffer (1, Buf_UP);
    SetIndexLabel (1, "UP");
    SetIndexDrawBegin (1, MA_Period * MA_K_Period);
    SetIndexArrow (1, 236);
    //----
    SetIndexStyle (2, DRAW_ARROW);
    SetIndexBuffer (2, Buf_DW);
    SetIndexLabel (2, "DN");
    SetIndexDrawBegin (2, MA_Period * MA_K_Period);
    SetIndexArrow (2, 238);
    //----     
    bia_PeriodMA[0] = MA_Period;
    bia_PeriodMA[1] = MA_Period * MA_K_Period;
    bb_VisualControl = IsVisualControl;
    bb_ControlBeginChangeTrend = (Use_ChangeTrend.MA > 0);
	 //----    
	 //SemaphoreReturn ("INIT");
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custor indicator deinitialization function                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int deinit()
{
//----
    //----     
    fObjectsDeleteAll ("MA_", -1, -1);
    //if (Semaphore_ON) {SemaphoreClose();}
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom indicator iteration function                              |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{  
    int li_Limit = fGet_CalculateBars (bia_PeriodMA[1], Bars_Recalculate);
//----
    if (li_Limit < 0) return (-1);
    //----  Limit  Bars_Recalculate, ,   
    if (li_Limit > Bars_Recalculate)
    {
        ArrayInitialize (Buf_Signal, STOP);
        ArrayInitialize (Buf_UP, EMPTY_VALUE);
        ArrayInitialize (Buf_DW, EMPTY_VALUE);
        //Print ("MA Signal: Limit - ", li_Limit);
    }
    int    li_Signal = STOP;
    double ld_Area, ld_curDeviation;
    for (int li_Bar = li_Limit; li_Bar >= 0; li_Bar--)
    {
        li_Signal = fGet_SignalMA (Symbol(), Period(), ld_curDeviation, bd_Deviation, bb_ControlBeginChangeTrend, li_Bar + SignalOnBar, VerificationBars);
        if (li_Signal == STOP) {Buf_Signal[li_Bar] = Buf_Signal[li_Bar+1]; continue;}
        ld_Area = iATR (Symbol(), 0, 20, li_Bar);
        if (li_Signal == BULL)
        {
            Buf_UP[li_Bar] = Low[li_Bar] - ld_Area * LowerArrowDisplacement;
            Buf_Signal[li_Bar] = BULL;
        }
        else if (li_Signal == BEAR)
        {
            Buf_DW[li_Bar] = High[li_Bar] + ld_Area * UpperArrowDisplacement;
            Buf_Signal[li_Bar] = BEAR;
        }
    }
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

